addpath_recurse('functions_general');


n = 34; % At least 34 correct trials 
% Electrodes that didn't meet n=34 have been removed.  
for i_randsamp = 1:50 
    m_chan = 1;
    % sub1

    sel_chan_stroop = [1:3 5];
    sel_chan_flanker = [1:3 5];
    sel_chan_number = [1:3 5];
    bad_channel = [4 9 11 14 16 17 22 25:27 30:32 36 39:42 47 49:52 57:66 74:86 92 96:99 102 106:111 113 114 116:121 124:131 133 136 ...
    141:143 145:146 150]; 
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 


    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub1','features_sub1.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub1{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub1{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub1{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub1{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub1{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub1{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub1{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub1{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub1{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub1{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub1{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub1{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end

    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    %% sub2
    sel_chan_stroop = [46 47 78:80];
    sel_chan_flanker = [46 47 78:80];
    sel_chan_number = [46 47 78:80];
            bad_channel = [4:6 10 16:21 23 26:32 36 37 44 45 48:55 60 67:70 72 75:77 81 92 102:110 113 118 119 126 139 142 150:153 ...
    158:160 169 170];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub2','features_sub2.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub2{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub2{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub2{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub2{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub2{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub2{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub2{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub2{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub2{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub2{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub2{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub2{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub3
    sel_chan_stroop = [99 100];
    sel_chan_flanker = [99 100];
    sel_chan_number = [99 100];
    bad_channel = [6 8:12 18:21 23:33 37 38 41 44 46:48 51:57 61 62 69:74 76:79 83 85:92 94 97 98 101:107 110 114:116 121 125 126 ...
    128 130 132:135 140:144 146:150 156 157 161 162 167 170 172:177 182:184 189 191 193 194];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub3','features_sub3.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub3{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub3{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub3{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub3{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub3{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub3{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub3{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub3{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub3{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub3{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub3{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub3{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub4
    sel_chan_stroop = [63 171 187];
    sel_chan_flanker = [63 171 187];
    sel_chan_number = [63 171 187];
    bad_channel = [1 4 5 7 15 16 19 21:43 45:47 50:52 59:53 55 58 60 61 62 64:66 69 73 75:79 85 89:91 96 99:101 105 109 110:112 116 118:120 123:126 ...
    128:142 146 154:165 170 172:177 181 184 186:188 190:197 200:209 211:213 216];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub4','features_sub4.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub4{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub4{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub4{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub4{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub4{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub4{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub4{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub4{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub4{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub4{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub4{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub4{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub5 
    sel_chan_stroop = [27 63 71];
    sel_chan_flanker = [27 63 71];
    sel_chan_number = [27 63 71];
    bad_channel = [4:8 11:13 15 16 22 26 28:31 36 37 40:44 46 49:46 48:52 55:58 61:70 72];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub5','features_sub5.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub5{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub5{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub5{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub5{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub5{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub5{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub5{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub5{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub5{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub5{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub5{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub5{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub6
    sel_chan_stroop = [69];
    sel_chan_flanker = [69];
    sel_chan_number = [69];
    bad_channel = [3 4 6 8 7:26 28 31:34 37:42 45:50 52 53 58:62 67 68 70:74 76:78 82:85 87 88 90 91 94 96 98:104 107 108 ...
    112:116 118:120];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub6','features_sub6.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub6{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub6{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub6{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub6{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub6{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub6{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub6{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub6{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub6{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub6{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub6{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub6{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
%     % sub7 
%     sel_chan_stroop = [];
%     sel_chan_flanker = [];
%     sel_chan_number = [];
%     bad_channel = [1:10 12 13 15 16 18:27 30:32 37:39 42 45:49 51:53 55 56 61 64 68 69 73:77 79 82:84 86 87 92:94 97 100:104 106];
%     sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
%     sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
%     sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
%     sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
% 
%     load(fullfile('data_recording','sub7','features_sub7.mat'));
%     if ~isempty(sel_chan)
%         for i = 1:length(sel_chan)
%             tent1 = conf_maxPower_stroop_con_sub7{sel_chan(i)};
%             tent2 = conf_maxPower_stroop_in_sub7{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_flanker_con_sub7{sel_chan(i)};
%             tent2 = conf_maxPower_flanker_in_sub7{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_number_con_sub7{sel_chan(i)};
%             tent2 = conf_maxPower_number_in_sub7{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;
% 
%             tent1 = conf_meanPower_stroop_con_sub7{sel_chan(i)};
%             tent2 = conf_meanPower_stroop_in_sub7{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_flanker_con_sub7{sel_chan(i)};
%             tent2 = conf_meanPower_flanker_in_sub7{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_number_con_sub7{sel_chan(i)};
%             tent2 = conf_meanPower_number_in_sub7{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;      
%         end
%     end
%     clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub8 
    sel_chan_stroop = [33];
    sel_chan_flanker = [33];
    sel_chan_number = [33];
    bad_channel = [5:11 14:16 18:20 23 24 28 32 34:39 42:47 49 50];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub8','features_sub8.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub8{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub8{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub8{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub8{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub8{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub8{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub8{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub8{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub8{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub8{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub8{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub8{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan


%     % sub9
%     sel_chan_stroop = [33];
%     sel_chan_flanker = [];
%     sel_chan_number = [];
%     sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
% 
%     load(fullfile('data_recording','sub9','features_sub9.mat'));
% 
%     if ~isempty(sel_chan)
%         for i = 1:length(sel_chan)
%             tent1 = conf_maxPower_stroop_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_stroop_in_sub9{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_flanker_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_flanker_in_sub9{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_number_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_number_in_sub9{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;
% 
%             tent1 = conf_meanPower_stroop_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_stroop_in_sub9{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_flanker_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_flanker_in_sub9{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_number_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_number_in_sub9{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;      
%         end
%     end
%     clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

%     % sub10
%     sel_chan_stroop = [];
%     sel_chan_flanker = [];
%     sel_chan_number = [];
%     sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
%     load(fullfile('data_recording','sub10','features_sub10.mat'));
% 
%     if ~isempty(sel_chan)
%         for i = 1:length(sel_chan)
%             tent1 = conf_maxPower_stroop_con_sub10{sel_chan(i)};
%             tent2 = conf_maxPower_stroop_in_sub10{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_flanker_con_sub10{sel_chan(i)};
%             tent2 = conf_maxPower_flanker_in_sub10{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_number_con_sub10{sel_chan(i)};
%             tent2 = conf_maxPower_number_in_sub10{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;
% 
%             tent1 = conf_meanPower_stroop_con_sub10{sel_chan(i)};
%             tent2 = conf_meanPower_stroop_in_sub10{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_flanker_con_sub10{sel_chan(i)};
%             tent2 = conf_meanPower_flanker_in_sub10{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_number_con_sub10{sel_chan(i)};
%             tent2 = conf_meanPower_number_in_sub10{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;      
%         end
%     end
%     clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub11
    sel_chan_stroop = [17];
    sel_chan_flanker = [17];
    sel_chan_number = [17];
bad_channel = [1 3:6 9:11 13:20,24:29 33:38 41:45 48:50 53 54 56 57 60:65 69 70,72 73 78:86,89,91:97 101:105]; 
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub11','features_sub11.mat'));    
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub11{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub11{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub11{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub11{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub11{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub11{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub11{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub11{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub11{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub11{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub11{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub11{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub12
    sel_chan_stroop = [];
    sel_chan_flanker = [];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub12','features_sub12.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub12{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub12{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub12{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub12{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub12{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub12{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub12{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub12{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub12{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub12{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub12{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub12{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub13
    sel_chan_stroop = [];
    sel_chan_flanker = [];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub13','features_sub13.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub13{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub13{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub13{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub13{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub13{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub13{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub13{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub13{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub13{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub13{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub13{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub13{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub14
    sel_chan_stroop = [1 17 85 94];
    sel_chan_flanker = [1 17 85 94];
    sel_chan_number = [1 17 85 94];
    bad_channel = [1:5 8:25 27:29 30:66 70:76 79:93 95:100,102:108];
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 

    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub14','features_sub14.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub14{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub14{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub14{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub14{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub14{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub14{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub14{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub14{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub14{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub14{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub14{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub14{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan


    % sub15
    sel_chan_stroop = [1 2 9 17 18 33 34];
    sel_chan_flanker = [1 2 9 17 18 33 34];
    sel_chan_number = [1 2 9 17 18 33 34];
bad_channel = [1 4 9,17 20 23 25 28:33 35:45 49 50 55:57 60:64 65:73 75,79:82 85 90 91]; 
    sel_chan_stroop = sort(setdiff(sel_chan_stroop,bad_channel)); 
    sel_chan_flanker = sort(setdiff(sel_chan_flanker,bad_channel)); 
    sel_chan_number = sort(setdiff(sel_chan_number,bad_channel)); 

    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub15','features_sub15.mat'));


    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub15{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub15{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub15{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub15{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub15{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub15{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub15{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub15{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub15{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub15{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub15{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub15{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub16
    sel_chan_stroop = [];
    sel_chan_flanker = [];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub16','features_sub16.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub16{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub16{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub16{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub16{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub16{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub16{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub16{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub16{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub16{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub16{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub16{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub16{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % SVM 
        n_sample = 34;
        % Stroop 
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 34;
        for i = 1:10 % 10-fold 
            X_train = [fea_stroop_con(train_ind(i,:),:);fea_stroop_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_stroop_con(test_ind(i,:),:);fea_stroop_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_stroop(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end

        % Flanker
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 52;
        for i = 1:10 % 10-fold 
            X_train = [fea_flanker_con(train_ind(i,:),:);fea_flanker_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_flanker_con(test_ind(i,:),:);fea_flanker_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_flanker(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end

        % Number
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 52;
        for i = 1:10 % 10-fold 
            X_train = [fea_number_con(train_ind(i,:),:);fea_number_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_number_con(test_ind(i,:),:);fea_number_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_number(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end
end    
%%
correct_stroop = correct_stroop(:); 
correct_flanker = correct_flanker(:); 
correct_number = correct_number(:); 
p_test(1) = permutationTest(correct_stroop(:),repmat(50,[numel(correct_stroop),1]),10000,'sidedness','larger');
p_test(2) = permutationTest(correct_flanker(:),repmat(50,[numel(correct_flanker),1]),10000,'sidedness','larger');
p_test(3) = permutationTest(correct_number(:),repmat(50,[numel(correct_number),1]),10000,'sidedness','larger');

% p_stroop_vs_flanker = permutationTest(correct_stroop(:),correct_flanker(:),10000);
% p_flanker_vs_number = permutationTest(correct_flanker(:),correct_number(:),10000);
% p_stroop_vs_number = permutationTest(correct_stroop(:),correct_number(:),10000);

% p_anova = randanova1([correct_stroop,correct_flanker,correct_number],[repmat(1,[1,10]),repmat(2,[1,10])...
%     repmat(3,[1,10])],10000);


%% Plot 
y = [mean(correct_stroop(:)),mean(correct_flanker(:)),mean(correct_number(:))];

sem = [std(correct_stroop(:))/sqrt(numel(correct_stroop)),std(correct_flanker(:))/sqrt(numel(correct_stroop)),std(correct_number(:))/sqrt(numel(correct_stroop))]; 
err = sem; 

x = [1, 1.5,2];
b = bar(x,y);
for i = 1:length(y)
    if i==1

            b = bar(x(i),y(i),'FaceColor',[0.968,0.501,0.547],'BarWidth', 0.4);
        hold on;
    elseif i==2

            b = bar(x(i),y(i),'FaceColor',[0.996,1,0.595],'BarWidth', 0.4);
        hold on;
    else

            b = bar(x(i),y(i),'FaceColor',[0.511 0.515 1],'BarWidth', 0.4);
        hold on;
    end
end

er = errorbar(x,y,err,err);    
er.Color = [0 0 0];                            
er.LineStyle = 'none'; 
er.CapSize = 5;

ylim([40 100])
xlim([0.7 2.3])
%xticks = [1 2 3];
%names = {'Stroop','Flanker','Number'};
hold on; 
set(gca,'XTickLabel',[]);set(gca,'XTick',[]);
line([0.5 3.5],[50 50],'color','k','linestyle','--','linewidth',1.5)
ylabel('Accuracy (%)');
legend('train&test=Stroop','train&test=Flanker','train&test=Number');
set(gca,'fontsize', 8,'box','off','FontName','Arial','tickDir','out','FontName','Arial')
