addpath_recurse('functions_general');


n = 34; % At least 34 correct trials 
% Electrodes that didn't meet n=34 have been removed.  
for i_randsamp = 1:50 
    m_chan = 1;
    % sub1
    sel_chan_stroop = [28 29 55 137 138 148];
    sel_chan_flanker = [134 137 148 149];
    sel_chan_number = [1 149];

    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub1','features_sub1.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub1{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub1{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub1{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub1{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub1{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub1{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub1{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub1{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub1{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub1{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub1{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub1{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end

    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    %% sub2
    sel_chan_stroop = [];
    sel_chan_flanker = [25];
    sel_chan_number = [155 156 157 146 117 122 123 124 168 163 128 93 97 99 101 15 86 87 83 84 85 61];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub2','features_sub2.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub2{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub2{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub2{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub2{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub2{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub2{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub2{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub2{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub2{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub2{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub2{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub2{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub3
    sel_chan_stroop = [165];
    sel_chan_flanker = [39 40 50 80 81 131 136 137 138 139 151 152 153 154 186];
    sel_chan_number = [1 22 40 50 63 68 81 95 136 139 185 186 187];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub3','features_sub3.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub3{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub3{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub3{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub3{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub3{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub3{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub3{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub3{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub3{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub3{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub3{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub3{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub4
    sel_chan_stroop = [167 151 178 81 84 72];
    sel_chan_flanker = [166 148 115 102 103 68 57 10 13];
    sel_chan_number = [67];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub4','features_sub4.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub4{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub4{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub4{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub4{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub4{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub4{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub4{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub4{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub4{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub4{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub4{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub4{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub5 
    sel_chan_stroop = [19 20 32 33];
    sel_chan_flanker = [];
    sel_chan_number = [32 33];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub5','features_sub5.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub5{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub5{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub5{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub5{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub5{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub5{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub5{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub5{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub5{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub5{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub5{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub5{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub6
    sel_chan_stroop = [27 51 86 66];
    sel_chan_flanker = [92 117];
    sel_chan_number = [5 89 117];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub6','features_sub6.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub6{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub6{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub6{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub6{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub6{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub6{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub6{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub6{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub6{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub6{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub6{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub6{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan
    % sub7 
    sel_chan_stroop = [62 63];
    sel_chan_flanker = [11];
    sel_chan_number = [99];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub7','features_sub7.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub7{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub7{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub7{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub7{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub7{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub7{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub7{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub7{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub7{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub7{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub7{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub7{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub8 
    sel_chan_stroop = [];
    sel_chan_flanker = [4];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub8','features_sub8.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub8{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub8{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub8{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub8{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub8{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub8{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub8{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub8{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub8{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub8{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub8{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub8{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan


%     % sub9
%     sel_chan_stroop = [33];
%     sel_chan_flanker = [];
%     sel_chan_number = [];
%     sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
% 
%     load(fullfile('data_recording','sub9','features_sub9.mat'));
% 
%     if ~isempty(sel_chan)
%         for i = 1:length(sel_chan)
%             tent1 = conf_maxPower_stroop_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_stroop_in_sub9{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_flanker_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_flanker_in_sub9{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_maxPower_number_con_sub9{sel_chan(i)};
%             tent2 = conf_maxPower_number_in_sub9{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;
% 
%             tent1 = conf_meanPower_stroop_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_stroop_in_sub9{sel_chan(i)};
%             fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
%             fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_flanker_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_flanker_in_sub9{sel_chan(i)};
%             fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
%             fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
%             tent1 = conf_meanPower_number_con_sub9{sel_chan(i)};
%             tent2 = conf_meanPower_number_in_sub9{sel_chan(i)};
%             fea_number_con(1:n,m_chan) = randsample(tent1,n);
%             fea_number_in(1:n,m_chan) = randsample(tent2,n);
%             m_chan =m_chan+1;      
%         end
%     end
%     clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub10
    sel_chan_stroop = [61 5 6 95 99];
    sel_chan_flanker = [11 31 47 53 56];
    sel_chan_number = [18 19 8];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub10','features_sub10.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub10{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub10{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub10{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub10{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub10{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub10{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub10{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub10{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub10{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub10{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub10{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub10{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub11
    sel_chan_stroop = [21 22 23 59 66];
    sel_chan_flanker = [7 71 77];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub11','features_sub11.mat'));    
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub11{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub11{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub11{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub11{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub11{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub11{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub11{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub11{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub11{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub11{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub11{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub11{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub12
    sel_chan_stroop = [];
    sel_chan_flanker = [7];
    sel_chan_number = [28 53 54];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub12','features_sub12.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub12{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub12{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub12{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub12{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub12{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub12{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub12{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub12{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub12{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub12{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub12{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub12{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub13
    sel_chan_stroop = [36 39 76 77];
    sel_chan_flanker = [39];
    sel_chan_number = [87];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub13','features_sub13.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub13{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub13{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub13{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub13{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub13{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub13{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub13{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub13{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub13{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub13{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub13{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub13{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub14
    sel_chan_stroop = [94];
    sel_chan_flanker = [68 69];
    sel_chan_number = [];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub14','features_sub14.mat'));

    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub14{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub14{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub14{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub14{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub14{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub14{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub14{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub14{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub14{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub14{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub14{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub14{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan


    % sub15
    sel_chan_stroop = [19 74 76 77];
    sel_chan_flanker = [15 54 83];
    sel_chan_number = [15];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));

    load(fullfile('data_recording','sub15','features_sub15.mat'));


    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub15{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub15{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub15{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub15{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub15{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub15{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub15{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub15{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub15{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub15{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub15{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub15{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % sub16
    sel_chan_stroop = [];
    sel_chan_flanker = [29 115 116];
    sel_chan_number = [29:32];
    sel_chan = sort(unique([sel_chan_stroop,sel_chan_flanker,sel_chan_number]));
    load(fullfile('data_recording','sub16','features_sub16.mat'));
    if ~isempty(sel_chan)
        for i = 1:length(sel_chan)
            tent1 = conf_maxPower_stroop_con_sub16{sel_chan(i)};
            tent2 = conf_maxPower_stroop_in_sub16{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_flanker_con_sub16{sel_chan(i)};
            tent2 = conf_maxPower_flanker_in_sub16{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_maxPower_number_con_sub16{sel_chan(i)};
            tent2 = conf_maxPower_number_in_sub16{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;

            tent1 = conf_meanPower_stroop_con_sub16{sel_chan(i)};
            tent2 = conf_meanPower_stroop_in_sub16{sel_chan(i)};
            fea_stroop_con(1:n,m_chan) = randsample(tent1,n);
            fea_stroop_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_flanker_con_sub16{sel_chan(i)};
            tent2 = conf_meanPower_flanker_in_sub16{sel_chan(i)};
            fea_flanker_con(1:n,m_chan) = randsample(tent1,n);
            fea_flanker_in(1:n,m_chan) = randsample(tent2,n);
            tent1 = conf_meanPower_number_con_sub16{sel_chan(i)};
            tent2 = conf_meanPower_number_in_sub16{sel_chan(i)};
            fea_number_con(1:n,m_chan) = randsample(tent1,n);
            fea_number_in(1:n,m_chan) = randsample(tent2,n);
            m_chan =m_chan+1;      
        end
    end
    clear sel_chan_stroop sel_chan_flanker sel_chan_number sel_chan

    % SVM 
        n_sample = 34;
        % Stroop 
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 34;
        for i = 1:10 % 10-fold 
            X_train = [fea_stroop_con(train_ind(i,:),:);fea_stroop_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_stroop_con(test_ind(i,:),:);fea_stroop_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_stroop(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end

        % Flanker
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 52;
        for i = 1:10 % 10-fold 
            X_train = [fea_flanker_con(train_ind(i,:),:);fea_flanker_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_flanker_con(test_ind(i,:),:);fea_flanker_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_flanker(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end

        % Number
        [train_ind, test_ind,n_test] = generateCrossValInd(n_sample); % n_sample = 52;
        for i = 1:10 % 10-fold 
            X_train = [fea_number_con(train_ind(i,:),:);fea_number_in(train_ind(i,:),:)];
            Y_train = [zeros(n_sample-n_test,1);ones(n_sample-n_test,1)];
            Mdl = fitcsvm(X_train,Y_train,'Standardize',true,'KernelFunction','linear');

            X_test = [fea_number_con(test_ind(i,:),:);fea_number_in(test_ind(i,:),:)];
            labels = predict(Mdl,X_test);
            Y_test = [zeros(n_test,1);ones(n_test,1)];
            n_correct = 0;
            for j = 1:length(labels)
                if labels(j)==Y_test(j)
                    n_correct = n_correct+1;
                end
            end
            correct_number(i_randsamp,i) = n_correct/length(Y_test)*100;
            clear Mdl
        end
end    
%%
correct_stroop = correct_stroop(:); 
correct_flanker = correct_flanker(:); 
correct_number = correct_number(:); 
p_test(1) = permutationTest(correct_stroop(:),repmat(50,[numel(correct_stroop),1]),10000,'sidedness','larger');
p_test(2) = permutationTest(correct_flanker(:),repmat(50,[numel(correct_flanker),1]),10000,'sidedness','larger');
p_test(3) = permutationTest(correct_number(:),repmat(50,[numel(correct_number),1]),10000,'sidedness','larger');

% p_stroop_vs_flanker = permutationTest(correct_stroop(:),correct_flanker(:),10000);
% p_flanker_vs_number = permutationTest(correct_flanker(:),correct_number(:),10000);
% p_stroop_vs_number = permutationTest(correct_stroop(:),correct_number(:),10000);

% p_anova = randanova1([correct_stroop,correct_flanker,correct_number],[repmat(1,[1,10]),repmat(2,[1,10])...
%     repmat(3,[1,10])],10000);


%% Plot 
y = [mean(correct_stroop(:)),mean(correct_flanker(:)),mean(correct_number(:))];

sem = [std(correct_stroop(:))/sqrt(numel(correct_stroop)),std(correct_flanker(:))/sqrt(numel(correct_stroop)),std(correct_number(:))/sqrt(numel(correct_stroop))]; 
err = sem; 

x = [1, 1.5,2];
b = bar(x,y);
for i = 1:length(y)
    if i==1

            b = bar(x(i),y(i),'FaceColor',[0.968,0.501,0.547],'BarWidth', 0.4);
        hold on;
    elseif i==2

            b = bar(x(i),y(i),'FaceColor',[0.996,1,0.595],'BarWidth', 0.4);
        hold on;
    else

            b = bar(x(i),y(i),'FaceColor',[0.511 0.515 1],'BarWidth', 0.4);
        hold on;
    end
end

er = errorbar(x,y,err,err);    
er.Color = [0 0 0];                            
er.LineStyle = 'none'; 
er.CapSize = 5;

ylim([40 100])
xlim([0.7 2.3])
%xticks = [1 2 3];
%names = {'Stroop','Flanker','Number'};
hold on; 
set(gca,'XTickLabel',[]);set(gca,'XTick',[]);
line([0.5 3.5],[50 50],'color','k','linestyle','--','linewidth',1.5)
ylabel('Accuracy (%)');
legend('train&test=Stroop','train&test=Flanker','train&test=Number');
set(gca,'fontsize', 8,'box','off','FontName','Arial','tickDir','out','FontName','Arial')
