%% Change for each subject
% update ylimit
% Substitute patient name

%% Initialize chronux toolbox
addpath_recurse('/n/scratch2/yx96//chronux_2_12/');
addpath_recurse('/n/scratch2/yx96//functions_general/');


%% Load files
%% Load files
good_channel = sort(setdiff(1:total_channel,bad_channel)); 

%%
load(fullfile('data_recording','sub13','trigger_info.mat'));
load(fullfile('data_recording','sub13','result_gamma','sub13_art_stroop.mat'));
load(fullfile('data_recording','sub13','result_gamma','A01_gamma_stroop_sub13.mat'));
load(fullfile('data_psychophysics','sub13','congruency_stroop'));
load(fullfile('data_psychophysics','sub13','stim_type_stroop'));
load(fullfile('data_psychophysics','sub13','vrt_stroop'));
load(fullfile('data_psychophysics','sub13','correct_stroop'));
load('t_trial.mat'); 



%% Analyze response aligned signal
before_voice = sr*2.5;
after_voice = sr*2.5; % give room for different subjects'performance, need to trim to same length in the end 
filter_space = sr; 
normRange = sr/2; 


for i_channel = 77%good_channel
    art = sub13_art_stroop{i_channel}; 
    %raw_voltage(i_channel,:) = ft_preproc_lowpassfilter(raw_voltage(i_channel,:),sr,300, 4, 'but');
    current = 1;
    correct_ind = 1; 
    for i = 1:height(trigger_info)
        if strcmp(trigger_info.task{i},'stroop') && strcmp(trigger_info.message{i},'stim_on')
            
            if  correct_stroop(correct_ind)==1 && ~ismember(correct_ind,art) 
                vrt =round(vrt_stroop(correct_ind)/1000*sr); 
                vrt_sec(current) = vrt_stroop(correct_ind)/1000;
                start = trigger_info.timestamp(i)+vrt-before_voice-filter_space; 
                ending = trigger_info.timestamp(i)+vrt+after_voice+filter_space; %3.5 s left to rt, 3.5 s right to rt 
               % trials_response_rAlign{current} = raw_voltage(i_channel,start:ending);               
                
                base_start = trigger_info.timestamp(i-1)-filter_space; 
                base_end = trigger_info.timestamp(i)+filter_space;
                %base{current} = raw_voltage(i_channel,base_start:base_end);                              
                
                stim_type(current) = stim_type_stroop(correct_ind); 
                if correct_ind <=30 
                    n_block(current) = 1;
                elseif correct_ind >30 && correct_ind <=60
                    n_block(current) = 2;
                elseif correct_ind >60 && correct_ind <=90
                    n_block(current) = 3;
                elseif correct_ind >90 && correct_ind <=120
                    n_block(current)= 4;
                elseif correct_ind >120 && correct_ind <=150
                    n_block(current) = 5;
                elseif correct_ind >150 && correct_ind <=180
                    n_block(current) = 6;
                elseif correct_ind >180 && correct_ind <=210
                    n_block(current) = 7;
                end
                
                current = current+1; 
                correct_ind = correct_ind+1; 
            else
                correct_ind = correct_ind+1; 
            end
        end
    end

    trials_matrix = A01_gamma_stroop_sub13{i_channel}; 
    
    type_1_ind = find(stim_type==1); n_1_ind = length(type_1_ind);
    type_2_ind = find(stim_type==2); n_2_ind = length(type_2_ind);
    type_3_ind = find(stim_type==3); n_3_ind = length(type_3_ind);
    type_4_ind = find(stim_type==4); n_4_ind = length(type_4_ind);
    type_5_ind = find(stim_type==5); n_5_ind = length(type_5_ind);
    type_6_ind = find(stim_type==6); n_6_ind = length(type_6_ind);
    type_7_ind = find(stim_type==7); n_7_ind = length(type_7_ind);
    type_8_ind = find(stim_type==8); n_8_ind = length(type_8_ind);
    type_9_ind = find(stim_type==9); n_9_ind = length(type_9_ind);


    matrix_1 = trials_matrix(type_1_ind,:); 
    matrix_2 = trials_matrix(type_2_ind,:); 
    matrix_3 = trials_matrix(type_3_ind,:); 
    matrix_4 = trials_matrix(type_4_ind,:); 
    matrix_5 = trials_matrix(type_5_ind,:); 
    matrix_6 = trials_matrix(type_6_ind,:); 
    matrix_7 = trials_matrix(type_7_ind,:); 
    matrix_8 = trials_matrix(type_8_ind,:); 
    matrix_9 = trials_matrix(type_9_ind,:); 

    t_now = t_trial(93:end);
    t_now = t_now-(t_now(1)-(-2.5)); % make the t_now(1) = -2.5, now response_time = 0; 
    t_now = t_now(1:size(matrix_1,2));
    
    mean_1 = mean(matrix_1); sem_1 = std(matrix_1)/sqrt(size(matrix_1,1));
    mean_2 = mean(matrix_2); sem_2 = std(matrix_2)/sqrt(size(matrix_2,1));
    mean_3 = mean(matrix_3); sem_3 = std(matrix_3)/sqrt(size(matrix_3,1));
    mean_4 = mean(matrix_4); sem_4 = std(matrix_4)/sqrt(size(matrix_4,1));
    mean_5 = mean(matrix_5); sem_5 = std(matrix_5)/sqrt(size(matrix_5,1));
    mean_6 = mean(matrix_6); sem_6 = std(matrix_6)/sqrt(size(matrix_6,1));
    mean_7 = mean(matrix_7); sem_7 = std(matrix_7)/sqrt(size(matrix_7,1));
    mean_8 = mean(matrix_8); sem_8 = std(matrix_8)/sqrt(size(matrix_8,1));
    mean_9 = mean(matrix_9); sem_9 = std(matrix_9)/sqrt(size(matrix_9,1));
    
    mean_vrt = nanmean(vrt_stroop); 
    ave_onset = -mean_vrt/1000;
    [~,start_point] = min(abs(t_now-ave_onset)); 
    [~,end_point] = min(abs(t_now-0));

    
               

    %% Prepare for plot 
    fix_onset = -mean_vrt/1000-0.5; %500 ms before average stimulus onset 
    [~,plot_start] = min(abs(t_now-fix_onset)); 
    plot_end = end_point;  
    t_plot = t_now(plot_start:plot_end); 
        
    mean_1 = mean_1(plot_start:plot_end); sem_1 = sem_1(plot_start:plot_end);
    mean_2 = mean_2(plot_start:plot_end); sem_2 = sem_2(plot_start:plot_end);
    mean_3 = mean_3(plot_start:plot_end); sem_3 = sem_3(plot_start:plot_end);
    mean_4 = mean_4(plot_start:plot_end); sem_4 = sem_4(plot_start:plot_end);
    mean_5 = mean_5(plot_start:plot_end); sem_5 = sem_5(plot_start:plot_end);
    mean_6 = mean_6(plot_start:plot_end); sem_6 = sem_6(plot_start:plot_end);
    mean_7 = mean_7(plot_start:plot_end); sem_7 = sem_7(plot_start:plot_end);
    mean_8 = mean_8(plot_start:plot_end); sem_8 = sem_8(plot_start:plot_end);
    mean_9 = mean_9(plot_start:plot_end); sem_9 = sem_9(plot_start:plot_end);
    
%% Line plot   
    %% Line plot   
    figure(i_channel)
    ylimit = 13;
    subplot(3,3,1)
    s1 = shadedErrorBar(t_plot,mean_1,sem_1,'lineprops',{'-k'});
    set(s1.edge,'LineWidth',0.01)
    s1.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-0.5 ylimit]);
    names = string([-2:0.4:2]);
    ylabel('Z-scored power');  
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('RED','Color','r');
    legend_txt = sprintf('C,n=%d',n_1_ind);
    legend([s1.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

    subplot(3,3,2)
    s2 = shadedErrorBar(t_plot,mean_2,sem_2,'lineprops',{'-r'});
    set(s2.edge,'LineWidth',0.01)
    s2.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','r','linestyle','--')
    title('RED','Color',[0 0.5 0]);
    legend_txt = sprintf('n=%d',n_2_ind);
    legend([s2.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

    subplot(3,3,3)
    s3 = shadedErrorBar(t_plot,mean_3,sem_3,'lineprops',{'-r'});
    set(s3.edge,'LineWidth',0.01)
    s3.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','r','linestyle','--')
    title('RED','Color','b');
    legend_txt = sprintf('n=%d',n_3_ind);
    legend([s3.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

    subplot(3,3,4)
    s4 = shadedErrorBar(t_plot,mean_4,sem_4,'lineprops',{'-r'});
    set(s4.edge,'LineWidth',0.01)
    s4.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    ylabel('Z-scored power'); 
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('GREEN','Color','r');
    legend_txt = sprintf('n=%d',n_4_ind);
    legend([s4.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

    subplot(3,3,5)
    s5 = shadedErrorBar(t_plot,mean_5,sem_5,'lineprops',{'-k'});
    set(s5.edge,'LineWidth',0.01)
    s5.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('GREEN','Color',[0 0.5 0]);
    legend_txt = sprintf('C,n=%d',n_5_ind);
    legend([s5.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')

    subplot(3,3,6)
    s6 = shadedErrorBar(t_plot,mean_6,sem_6,'lineprops',{'-r'});
    set(s6.edge,'LineWidth',0.01)
    s6.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('GREEN','Color','b');
    legend_txt = sprintf('I,n=%d',n_6_ind);
    legend([s6.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')  

    subplot(3,3,7)
    s7 = shadedErrorBar(t_plot,mean_7,sem_7,'lineprops',{'-r'});
    set(s7.edge,'LineWidth',0.01)
    s7.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    ylabel('Z-scored power'); 
    names = string([-2:0.4:2]);
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('BLUE','Color','r');
    xlabel('Time to response (s)');
    legend_txt = sprintf('n=%d',n_7_ind);
    legend([s7.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
    set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off')
    
    subplot(3,3,8)
    s8 = shadedErrorBar(t_plot,mean_8,sem_8,'lineprops',{'-r'});
    set(s8.edge,'LineWidth',0.01)
    s8.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    xlabel('Time to response (s)');
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('BLUE','Color',[0 0.5 0]);
    legend_txt = sprintf('n=%d',n_8_ind);
    legend([s8.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
    set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off','YTickLabel',[])
    
    subplot(3,3,9)
    s9 = shadedErrorBar(t_plot,mean_9,sem_9,'lineprops',{'-k'});
    set(s9.edge,'LineWidth',0.01)
    s9.mainLine.LineWidth = 1.5;
    xlim([t_plot(1) 0])
    ylim([-1 ylimit]);
    names = string([-2:0.4:2]);
    line([0-mean_vrt/1000,0-mean_vrt/1000],[-1 ylimit],'color','k','linestyle','--')
    title('BLUE','Color','b');
    xlabel('Time to response (s)');
    legend_txt = sprintf('n=%d',n_9_ind);
    legend([s9.mainLine],{legend_txt},'FontSize',8,'Location','northwest','FontName','Arial');
    set(gca,'fontsize', 10,'xtick',[-2:0.4:2],'xticklabel',names,'TickDir','out','FontName','Arial','box','off','YTickLabel',[])


    

%%    
    clear congruency trials_matrix trials_response_rAlign base p h trials_stimAlign Ai Ac start1 end1 start2 end2 h s1 s2 params names con_matrix_2 incon_matrix_1...
        binAve_con binAve_in binMean_con binMean_in sum5 S_in_matrix sum5_null matrix_mixed sum_mean matrix_1 matrix_2 matrix_3 matrix_4 matrix_5 matrix_6 matrix_7 matrix_8 matrix_9 stim_type
end




